import re, string, sys

# takes two optional parameters: input file name and output file name
try:
    input = sys.argv[1]
except IndexError:
    input = "locations_raw.txt"
try:
    output = sys.argv[2]
except IndexError:
    output = "locations_output.txt"

f_in=open(input, "r")
f_out=open(output, "w")

# write variable names on first line so they get insheeted in to stata
f_out.write("|".join(["appl_id", "inv_name", "inv_city", "inv_state", "inv_country\n"]))


usstates = ['AK', 'AL', 'AR', 'AZ', 'CA', 'CO', 'CT', 'DC', 'DE',
          'FL', 'GA', 'HI', 'IA', 'ID', 'IL', 'IN', 'KS', 'KY',
          'LA', 'MA', 'MD', 'ME', 'MI', 'MN', 'MO', 'MS', 'MT',
          'NC', 'ND', 'NE', 'NH', 'NJ', 'NM', 'NV', 'NY', 'OH',
          'OK', 'OR', 'PA', 'RI', 'SC', 'SD', 'TN', 'TX', 'UT',
          'VA', 'VT', 'WA', 'WI', 'WV', 'WY']


def parseLine(line):
    app, text = line.split("\t")
    if text=="\n" or len(text)<3: # it's a blank location
        return "|".join([app, re.sub("\n", "", text), "", "", "\n"])
    ## country
    if text[-2]==")":
        ## it has a country if end looks like: '... , PASADENA, CA (US)\n'
        country = text[-4:-2]
        text = text[:-5]
    else:
        country = ""
    try:
        name, location = re.split(" , ", text) # works quite well
    except ValueError: # " , " wasn't found
        name, location = "", ""
    try:
        citystate = location.split(",")
        city = string.strip(",".join(citystate[:-1]))
        state = string.strip(citystate[-1])
    except ValueError or IndexError: # "," wasn't found
        city = ""
        state = ""
    if state in usstates and country=="":
        country="US"
    if name == "": # something didn't work...
        name=re.sub("\n", "", text)
    return "|".join([app, name, city, state, country+"\n"])
 
for line in f_in.readlines():
    f_out.write(parseLine(line))
    
f_in.close()
f_out.close()
